searchData={"items":[{"type":"module","title":"Colonel","doc":"Colonel provides functions that could be imagined in `Kernel` but aren't there.\n\nFunctions will end up in this module after being proven in `Colonel.Experimental`.","ref":"Colonel.html"},{"type":"module","title":"Colonel.Experimental","doc":"A proving ground for functions before they make it into `Colonel` proper.","ref":"Colonel.Experimental.html"},{"type":"function","title":"Colonel.Experimental.add/2","doc":"Translates to `left + right`.","ref":"Colonel.Experimental.html#add/2"},{"type":"function","title":"Examples - Colonel.Experimental.add/2","doc":"iex> add(1, 2)\n    3","ref":"Colonel.Experimental.html#add/2-examples"},{"type":"function","title":"Colonel.Experimental.and?/2","doc":"Translates to `left && right`.","ref":"Colonel.Experimental.html#and?/2"},{"type":"function","title":"Examples - Colonel.Experimental.and?/2","doc":"iex> and?(nil, false)\n    nil\n\n    iex> and?(1, nil)\n    nil\n\n    iex> and?(false, 2)\n    false\n\n    iex> and?(true, 2)\n    2","ref":"Colonel.Experimental.html#and?/2-examples"},{"type":"function","title":"Colonel.Experimental.binary_concat/2","doc":"Translates to `left <> right`.","ref":"Colonel.Experimental.html#binary_concat/2"},{"type":"function","title":"Examples - Colonel.Experimental.binary_concat/2","doc":"iex> binary_concat(\"foo\", \"bar\")\n    \"foobar\"","ref":"Colonel.Experimental.html#binary_concat/2-examples"},{"type":"function","title":"Colonel.Experimental.divide/2","doc":"Translates to `left / right`.","ref":"Colonel.Experimental.html#divide/2"},{"type":"function","title":"Examples - Colonel.Experimental.divide/2","doc":"iex> divide(1, 2)\n    0.5","ref":"Colonel.Experimental.html#divide/2-examples"},{"type":"function","title":"Colonel.Experimental.equal?/2","doc":"Translates to `left == right`.","ref":"Colonel.Experimental.html#equal?/2"},{"type":"function","title":"Examples - Colonel.Experimental.equal?/2","doc":"iex> equal?(1, 2)\n    false\n\n    iex> equal?(1, 1.0)\n    true","ref":"Colonel.Experimental.html#equal?/2-examples"},{"type":"function","title":"Colonel.Experimental.greater_than?/2","doc":"Translates to `left > right`.","ref":"Colonel.Experimental.html#greater_than?/2"},{"type":"function","title":"Examples - Colonel.Experimental.greater_than?/2","doc":"iex> greater_than?(1, 2)\n    false","ref":"Colonel.Experimental.html#greater_than?/2-examples"},{"type":"function","title":"Colonel.Experimental.greater_than_or_equal?/2","doc":"Translates to `left >= right`.","ref":"Colonel.Experimental.html#greater_than_or_equal?/2"},{"type":"function","title":"Examples - Colonel.Experimental.greater_than_or_equal?/2","doc":"iex> greater_than_or_equal?(1, 2)\n    false","ref":"Colonel.Experimental.html#greater_than_or_equal?/2-examples"},{"type":"function","title":"Colonel.Experimental.inequal?/2","doc":"Translates to `left != right`.","ref":"Colonel.Experimental.html#inequal?/2"},{"type":"function","title":"Examples - Colonel.Experimental.inequal?/2","doc":"iex> inequal?(1, 2)\n    true\n\n    iex> inequal?(1, 1.0)\n    false","ref":"Colonel.Experimental.html#inequal?/2-examples"},{"type":"function","title":"Colonel.Experimental.iodata_inspect/2","doc":"Does the same thing as `inspect/2` but returns IO data instead of a string.\n\nSee [\"`iodata` and `chardata`\"](`e:elixir:io-and-the-file-system.html#iodata-and-chardata`).","ref":"Colonel.Experimental.html#iodata_inspect/2"},{"type":"function","title":"Examples - Colonel.Experimental.iodata_inspect/2","doc":"iex> iodata_inspect(:foo)\n    [\":foo\"]\n\n    iex> iodata_inspect([1, 2, 3, 4, 5], limit: 3)\n    [\"[\", \"1\", \",\", \" \", \"2\", \",\", \" \", \"3\", \",\", \" \", \"...\", \"]\"]\n\n    iex> iodata_inspect([1, 2, 3], pretty: true, width: 0)\n    [\"[\", \"1\", \",\", \"\\n \", \"2\", \",\", \"\\n \", \"3\", \"]\"]\n\n    iex> iodata_inspect(\"olá\" <> <<0>>)\n    [\"<<\", \"111\", \",\", \" \", \"108\", \",\", \" \", \"195\", \",\", \" \", \"161\", \",\", \" \", \"0\", \">>\"]\n\n    iex> iodata_inspect(\"olá\" <> <<0>>, binaries: :as_strings)\n    [~S(\"olá\\0\")]\n\n    iex> iodata_inspect(\"olá\", binaries: :as_binaries)\n    [\"<<\", \"111\", \",\", \" \", \"108\", \",\", \" \", \"195\", \",\", \" \", \"161\", \">>\"]\n\n    iex> iodata_inspect([0 | ~c\"bar\"])\n    [\"[\", \"0\", \",\", \" \", \"98\", \",\", \" \", \"97\", \",\", \" \", \"114\", \"]\"]\n\n    iex> iodata_inspect(100, base: :octal)\n    [\"0o144\"]\n\n    iex> iodata_inspect(100, base: :hex)\n    [\"0x64\"]","ref":"Colonel.Experimental.html#iodata_inspect/2-examples"},{"type":"function","title":"Colonel.Experimental.less_than?/2","doc":"Translates to `left < right`.","ref":"Colonel.Experimental.html#less_than?/2"},{"type":"function","title":"Examples - Colonel.Experimental.less_than?/2","doc":"iex> less_than?(1, 2)\n    true","ref":"Colonel.Experimental.html#less_than?/2-examples"},{"type":"function","title":"Colonel.Experimental.less_than_or_equal?/2","doc":"Translates to `left <= right`.","ref":"Colonel.Experimental.html#less_than_or_equal?/2"},{"type":"function","title":"Examples - Colonel.Experimental.less_than_or_equal?/2","doc":"iex> less_than_or_equal?(1, 2)\n    true","ref":"Colonel.Experimental.html#less_than_or_equal?/2-examples"},{"type":"function","title":"Colonel.Experimental.list_concat/2","doc":"Translates to `left ++ right`.","ref":"Colonel.Experimental.html#list_concat/2"},{"type":"function","title":"Examples - Colonel.Experimental.list_concat/2","doc":"iex> list_concat([1], [2, 3])\n    [1, 2, 3]","ref":"Colonel.Experimental.html#list_concat/2-examples"},{"type":"function","title":"Colonel.Experimental.list_subtract/2","doc":"Translates to `left -- right`.","ref":"Colonel.Experimental.html#list_subtract/2"},{"type":"function","title":"Examples - Colonel.Experimental.list_subtract/2","doc":"iex> list_subtract([1, 2, 3], [1, 2])\n    [3]","ref":"Colonel.Experimental.html#list_subtract/2-examples"},{"type":"function","title":"Colonel.Experimental.multiply/2","doc":"Translates to `left * right`.","ref":"Colonel.Experimental.html#multiply/2"},{"type":"function","title":"Examples - Colonel.Experimental.multiply/2","doc":"iex> multiply(1, 2)\n    2","ref":"Colonel.Experimental.html#multiply/2-examples"},{"type":"function","title":"Colonel.Experimental.negative/1","doc":"Translates to `-value`.","ref":"Colonel.Experimental.html#negative/1"},{"type":"function","title":"Examples - Colonel.Experimental.negative/1","doc":"iex> negative(2)\n    -2","ref":"Colonel.Experimental.html#negative/1-examples"},{"type":"function","title":"Colonel.Experimental.not?/1","doc":"Translates to `!value`.","ref":"Colonel.Experimental.html#not?/1"},{"type":"function","title":"Examples - Colonel.Experimental.not?/1","doc":"iex> not?(nil)\n    true\n\n    iex> not?(1)\n    false","ref":"Colonel.Experimental.html#not?/1-examples"},{"type":"function","title":"Colonel.Experimental.or?/2","doc":"Translates to `left || right`.","ref":"Colonel.Experimental.html#or?/2"},{"type":"function","title":"Examples - Colonel.Experimental.or?/2","doc":"iex> or?(nil, false)\n    false\n\n    iex> or?(1, nil)\n    1\n\n    iex> or?(false, 2)\n    2\n\n    iex> or?(true, 2)\n    true","ref":"Colonel.Experimental.html#or?/2-examples"},{"type":"function","title":"Colonel.Experimental.positive/1","doc":"Translates to `+value`.","ref":"Colonel.Experimental.html#positive/1"},{"type":"function","title":"Examples - Colonel.Experimental.positive/1","doc":"iex> positive(1)\n    1","ref":"Colonel.Experimental.html#positive/1-examples"},{"type":"macro","title":"Colonel.Experimental.recursive/1","doc":"Build a recursive anonymous function.\n\nThis macro must be passed the function in the `fn` syntax.\n\nGenerated functions can call themselves using `super`.","ref":"Colonel.Experimental.html#recursive/1"},{"type":"macro","title":"Examples - Colonel.Experimental.recursive/1","doc":"iex> reverse = recursive fn\n    ...>   [], acc -> acc\n    ...>   [head | tail], acc -> super(tail, [head | acc])\n    ...> end\n    iex> reverse.([1, 2, 3], [])\n    [3, 2, 1]","ref":"Colonel.Experimental.html#recursive/1-examples"},{"type":"macro","title":"Colonel.Experimental.sigil_i/2","doc":"Handles the sigil `~i` for iodata.\n\nSee [\"`iodata` and `chardata`\"](`e:elixir:io-and-the-file-system.html#iodata-and-chardata`).","ref":"Colonel.Experimental.html#sigil_i/2"},{"type":"macro","title":"Modifiers - Colonel.Experimental.sigil_i/2","doc":"- `s`: interpolated values should be transformed by `to_string/1` (default)\n  - `i`: interpolated values should be transformed by `iodata_inspect/1`\n  - `d`: interpolated values are already iodata/chardata and do not need transformed\n\nUsing the `~i` sigil with the `s` or `i` modifiers will always return iodata. The `d` modifier\nallows for chardata that is not iodata by passing through interpolated chardata.\n\n> ##","ref":"Colonel.Experimental.html#sigil_i/2-modifiers"},{"type":"macro","title":"The `d` modifier {: .warning} - Colonel.Experimental.sigil_i/2","doc":">\n> The `d` modifier does not transform interpolated values, so they will appear in the generated\n> list as-is. This makes the operation cheaper when interpolated values are already\n> iodata/chardata but allows construction of invalid iodata/chardata. Care should be taken when\n> using the `d` modifier that all interpolated values are valid iodata/chardata.","ref":"Colonel.Experimental.html#sigil_i/2-the-d-modifier-warning"},{"type":"macro","title":"Examples - Colonel.Experimental.sigil_i/2","doc":"iex> ~i\"some #{[\"list\", [\"of\", \"nested\"], \"values\"]} and #{:such}\"\n    [\"some \", \"listofnestedvalues\", \" and \", \"such\"]\n\n    iex> ~i\"some #{[\"list\", [\"of\", \"nested\"], \"values\"]} and #{:such}\"s\n    [\"some \", \"listofnestedvalues\", \" and \", \"such\"]\n\n    iex> ~i\"some #{[\"list\", [\"of\", \"nested\"], \"values\"]} and #{:such}\"i\n    [\n      \"some \",\n      [\n        \"[\",\n        \"\",\n        ~S(\"list\"),\n        \",\",\n        \" \",\n        \"[\",\n        ~S(\"of\"),\n        \",\",\n        \" \",\n        ~S(\"nested\"),\n        \"]\",\n        \",\",\n        \" \",\n        ~S(\"values\"),\n        \"\",\n        \"]\"\n      ],\n      \" and \",\n      [\":such\"]\n    ]\n\n    iex> ~i\"some #{[\"list\", [\"of\", \"nested\"], \"values\"]} and #{to_string(:such)}\"d\n    [\"some \", [\"list\", [\"of\", \"nested\"], \"values\"], \" and \", \"such\"]","ref":"Colonel.Experimental.html#sigil_i/2-examples"},{"type":"function","title":"Colonel.Experimental.strictly_equal?/2","doc":"Translates to `left === right`.","ref":"Colonel.Experimental.html#strictly_equal?/2"},{"type":"function","title":"Examples - Colonel.Experimental.strictly_equal?/2","doc":"iex> strictly_equal?(1, 2)\n    false\n\n    iex> strictly_equal?(1, 1.0)\n    false","ref":"Colonel.Experimental.html#strictly_equal?/2-examples"},{"type":"function","title":"Colonel.Experimental.strictly_inequal?/2","doc":"Translates to `left !== right`.","ref":"Colonel.Experimental.html#strictly_inequal?/2"},{"type":"function","title":"Examples - Colonel.Experimental.strictly_inequal?/2","doc":"iex> strictly_inequal?(1, 2)\n    true\n\n    iex> strictly_inequal?(1, 1.0)\n    true","ref":"Colonel.Experimental.html#strictly_inequal?/2-examples"},{"type":"function","title":"Colonel.Experimental.subtract/2","doc":"Translates to `left - right`.","ref":"Colonel.Experimental.html#subtract/2"},{"type":"function","title":"Examples - Colonel.Experimental.subtract/2","doc":"iex> subtract(1, 2)\n    -1","ref":"Colonel.Experimental.html#subtract/2-examples"},{"type":"extras","title":"Colonel","doc":"# [Colonel](https://youtu.be/0Xb-oLS-cyY?t=18)\n\nColonel is intended to provide functions that could be imagined in Kernel but aren't there.","ref":"readme.html"},{"type":"extras","title":"Installation - Colonel","doc":"If [available in Hex](https://hex.pm/docs/publish), the package can be installed\nby adding `colonel` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:colonel, \"~> 0.1.0\"}\n  ]\nend\n```\n\nDocumentation can be generated with [ExDoc](https://github.com/elixir-lang/ex_doc)\nand published on [HexDocs](https://hexdocs.pm). Once published, the docs can\nbe found at  .","ref":"readme.html#installation"},{"type":"extras","title":"Ideas - Colonel","doc":"#","ref":"readme.html#ideas"},{"type":"extras","title":"Formatted Strings - Colonel","doc":"Can we do anything to make [:io_lib.format/2](https://www.erlang.org/doc/man/io_lib.html#format-2) more Elixir-friendly?\n\n#","ref":"readme.html#formatted-strings"},{"type":"extras","title":"Then/Tap With/If - Colonel","doc":"Frequently I find myself wanting to modify a value only if a condition is met. Often this means rebinding variables to\nconditional expressions.\n\n\"with\" expressions are convenient for modifying values only if they meet a certain condition. \"if\" expressions require\nan \"else\" to return values when the condition is not met. But neither is great for modifying values via piping with `|>`.\nNot without combining with [then/2](https://hexdocs.pm/elixir/Kernel.html#then/2).\n\nI like to imagine a construct that makes it easy to make conditional changes to a value in a pipeline.\n\n#","ref":"readme.html#then-tap-with-if"},{"type":"extras","title":"Function Wrapper - Colonel","doc":"I sometimes find myself wanting to build anonymous functions that return already-known values. Often these functions are\n0-arity, but occasionally they take arguments.\n\nI'm imagining a function that does something like this:\n```elixir\nfn_wrap({:ok, value})\n#=> fn -> {:ok, value} end\n\nfn_wrap([a, b, c], 2)\n#=> fn _, _ -> [a, b, c] end\n```\n\n#","ref":"readme.html#function-wrapper"},{"type":"extras","title":"Non-Integer Ranges - Colonel","doc":"Ranges are great for testing inclusion and generating series, but the built-in ones only support integers. It would be\ncool to have ranges that could support any orderable and/or incrementable values, such as floats or dates.\n\n#","ref":"readme.html#non-integer-ranges"},{"type":"extras","title":"Local Accumulators - Colonel","doc":"This one would be more an exercise to see if I could do it than something I personally want, but could the proposed\n[local accumulator](https://elixirforum.com/t/local-accumulators-for-cleaner-comprehensions/60130) functionality be\nprovided by a library instead of being built into the language?\n\n#","ref":"readme.html#local-accumulators"},{"type":"extras","title":"Pipe-Friendly Flat Map Reduce - Colonel","doc":"I see [Enum.flat_map_reduce/3](https://hexdocs.pm/elixir/Enum.html#flat_map_reduce/3) as one of the most powerful\nconstructs for working through enumerables, but if your acc is very complicated it can get unwieldy.\n\nWould there be some structure into which we could reduce to provide a similar functionality? I'm picturing something\nlike this:\n```elixir\nacc =\n  for value <- my_enumerable, reduce: Acc.new(a: %{}, b: 0) do\n    acc ->\n      acc\n      |> Acc.yield(value * 2)\n      |> Acc.update(:a, &Map.put(&1, value, acc[:b]))\n      |> Acc.update(:b, & &1 + value)\n  end\n\n# get list\nAcc.yielded(acc)\n\n# get accumulated value\nacc[:a]\n```","ref":"readme.html#pipe-friendly-flat-map-reduce"},{"type":"extras","title":"Changelog","doc":"# Changelog","ref":"changelog.html"},{"type":"extras","title":"0.2.0 (2024-06-15) - Changelog","doc":"#","ref":"changelog.html#0-2-0-2024-06-15"},{"type":"extras","title":"Iodata conveniences - Changelog","doc":"[Iodata and chardata](https://hexdocs.pm/elixir/io-and-the-file-system.html#iodata-and-chardata) can be cheaper than strings to build, but they're often not as nice to work with. `Colonel` now provides two conveniences for working with iodata and chardata:\n- `Colonel.Experimental.iodata_inspect/2` does what `Kernel.inspect/2` does but returns the result as iodata instead of building one string from it.\n- `Colonel.Experimental.sigil_i/2` provides an `~i` sigil for building iodata or chardata with a string interpolation syntax.","ref":"changelog.html#iodata-conveniences"},{"type":"extras","title":"0.1.0 (2024-05-02) - Changelog","doc":"#","ref":"changelog.html#0-1-0-2024-05-02"},{"type":"extras","title":"Named Aliases for Operators - Changelog","doc":"Operators look great inline, but there some cases where named functions work better:\n- When piping function calls with `|>`, operators can be a bit strange. You either have to pipe into an anonymous function using the operator, or you have to use the fully-qualified name like `|> Kernel.+(1)`.\n- When creating anonymous functions with the `&` syntax, you can wrap named functions without additional parentheses.\n\nColonel 0.1.0 introduces to `Colonel.Experimental` a number of aliases for common operators:\n\n`Colonel.Experimental` Function       | Operator\n------------------------------------- | --------\n`add(left, right)`                    | `left + right`\n`and?(left, right)`                   | `left && right`\n`binary_concat(left, right)`          | `left <> right`\n`divide(left, right)`                 | `left / right`\n`equal?(left, right)`                 | `left == right`\n`greater_than?(left, right)`          | `left > right`\n`greater_than_or_equal?(left, right)` | `left >= right`\n`inequal?(left, right)`               | `left != right`\n`less_than?(left, right)`             | `left < right`\n`less_than_or_equal?(left, right)`    | `left <= right`\n`list_concat(left, right)`            | `left ++ right`\n`list_subtract(left, right)`          | `left -- right`\n`multiply(left, right)`               | `left * right`\n`negative(value)`                     | `-value`\n`not?(value)`                         | `!value`\n`or?(left, right)`                    | `left \\|\\| right`\n`positive(value)`                     | `+value`\n`strictly_equal?(left, right)`        | `left === right`\n`strictly_inequal?(left, right)`      | `left !== right`\n`subtract(left, right)`               | `left - right`\n\n#","ref":"changelog.html#named-aliases-for-operators"},{"type":"extras","title":"Recursive Anonymous Functions - Changelog","doc":"Anonymous functions can't reference themselves without taking a function as an argument and being called with it. `Colonel.Experimental.recursive/1` takes care of that boilerplate to make recursive anonymous functions.","ref":"changelog.html#recursive-anonymous-functions"}],"content_type":"text/markdown"}